﻿using System;
using System.Collections;

namespace ConsoleApplication20
{
    class Program
    {
        static void Main(string[] args)
        {
            BinNode root = GenerateTree();

            BinNode node1 = root.Right.Right.Left;
            BinNode node2 = root.Right.Right.Right;

            BinNode result = FindParentNode(root, node1, node2);

            Console.Read();
        }

        static BinNode FindParentNode(BinNode root, BinNode node1, BinNode node2)
        {
            Stack stack1 = new Stack();
            GetPositionByNode(root, node1, ref stack1);

            Stack stack2 = new Stack();
            GetPositionByNode(root, node2, ref stack2);

            BinNode tempNode = null;
            while (stack1.Peek() == stack2.Peek())
            {
                tempNode = (BinNode)stack1.Pop();
                stack2.Pop();
            }

            return tempNode;
        }

        static bool GetPositionByNode(BinNode root, BinNode node, ref Stack stack)
        {
            if (root == null)
                return false;

            if (root == node)
            {
                stack.Push(root);
                return true;
            }

            if (GetPositionByNode(root.Left, node, ref stack) || GetPositionByNode(root.Right, node, ref stack))
            {
                stack.Push(root);
                return true;
            }

            return false;
        }

        ////      13
        ////   10    15
        //// 5   11    17
        ////         16  22
        public static BinNode GenerateTree()
        {
            BinNode element7 = new BinNode(11, null, null);
            BinNode element6 = new BinNode(22, null, null);
            BinNode element5 = new BinNode(16, null, null);
            BinNode element4 = new BinNode(17, element5, element6);
            BinNode element3 = new BinNode(5, null, null);
            BinNode element2 = new BinNode(15, null, element4);
            BinNode element1 = new BinNode(10, element3, element7);
            BinNode root = new BinNode(13, element1, element2);

            return root;
        }
    }

    public class BinNode
    {
        public int Element;
        public BinNode Left;
        public BinNode Right;

        public BinNode(int element, BinNode left, BinNode right)
        {
            this.Element = element;
            this.Left = left;
            this.Right = right;
        }

        public bool IsLeaf()
        {
            return this.Left == null && this.Right == null;
        }
    }
}